#uses "CsKeyboardHookCtrlExt"
#uses "barco"
#uses "CsVideoGUI.cll"

/**
  Library mit warapper funktionen von stdTraffic alt auf stdTraffic 3.15
*/

/** 
*/
void wrapper_init()
{
  if ( !globalExists("glob_bCheckDpPara") )
  {
    addGlobal("glob_bCheckDpPara", BOOL_VAR);
    glob_bCheckDpPara = true;
  }
  
  if ( !globalExists("glob_dsDpOutputPatternResource") )
  {
    addGlobal("glob_dsDpOutputPatternResource", DYN_STRING_VAR);
    glob_dsDpOutputPatternResource = makeDynString();
  }
  
  if ( !globalExists("glob_dsAreaShortcutResource") )
  {
    addGlobal("glob_dsAreaShortcutResource", DYN_STRING_VAR);
    glob_dsAreaShortcutResource = makeDynString();

    dpGet("_Areas.UserName", glob_dsAreaShortcutResource);
    
  }
 
  if ( !globalExists("glob_dsAreaShortcutProjectResource") )
  {
    addGlobal("glob_dsAreaShortcutProjectResource", DYN_STRING_VAR);
    glob_dsAreaShortcutProjectResource = makeDynString();
    
    dpGet("_Areas.Comment", glob_dsAreaShortcutProjectResource);
  }
  
  if ( !globalExists("glob_dsAreaDpAuthorityResource") )
  {
    addGlobal("glob_dsAreaDpAuthorityResource", DYN_STRING_VAR);
    glob_dsAreaDpAuthorityResource = makeDynString();
    
    string sPath = getPath(DATA_REL_PATH, "stdTraffic/config/stdTraffic_authority.cfg");
    
    for ( int i = 1; i <= dynlen(glob_dsAreaShortcutResource); i++ )
    {
      dynAppend(glob_dsAreaDpAuthorityResource, stdTraffic_intern_paCfgReadValueDflt(sPath, "authority_old", glob_dsAreaShortcutResource[i]));
    }
  }
  
  if ( !globalExists("glob_dsWorkStationResource") )
  {
    addGlobal("glob_dsWorkStationResource", DYN_STRING_VAR);
    string sPath = getPath(DATA_REL_PATH, "stdTraffic/config/stdTraffic_hmi.cfg");
    glob_dsWorkStationResource = stdTraffic_intern_paCfgReadValueList(sPath, "workstations", "workstation");
  }
  
  if ( !dpExists("sys_ui_" + myManNum() + ".") )
    dpCreate("sys_ui_" + myManNum(), "sys_ui");
  
  if ( !dpExists("sys_lampentest_"+myManNum()+".ein") )
    dpCreate("sys_lampentest_"+myManNum(), "sys_lampentest");
    
  dpConnect("wrapper_lampenTestCB", "sys_lampentest_"+myManNum()+".ein");
    
  //Barco variablen initialisieren
  barco_initVars();
  
  //default videos aufschalten beim ummelden
  barco_initUserChange();
  
  //joistick initialisieren
  // INIT Joystick
	 startThread("CsVideoGUI_findJoystick");
  
  // INIT Keyboard
  if(isFunctionDefined("CsKeyboardHook_Initialize"))
  {
    DebugTN("CsVideoGUI_init","initialize KeyboardCallback");
    CsKeyboardHook_Initialize("CsVideoGUI_handleKey");
  		CsKeyboardHook_SetReportButton("VK_ADD");
  		CsKeyboardHook_SetReportButton("VK_SUBTRACT");
  		CsKeyboardHook_SetReportButton("VK_MULTIPLY");
  		CsKeyboardHook_SetReportButton("VK_DIVIDE");
  		CsKeyboardHook_SetReportButton("VK_RETURN");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD0");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD1");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD2");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD3");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD4");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD5");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD6");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD7");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD8");
  		CsKeyboardHook_SetReportButton("VK_NUMPAD9");
		
  		CsKeyboardHook_SetControlActive(true);
  }
}

/** 
  @param a_sDpe 
  @return 
*/
bool CsObject_dpExists(string a_sDpe)
{
  dyn_string ds;
  
  strreplace(a_sDpe, " ", "");
  strreplace(a_sDpe, "@", ",");
  
  ds = strsplit(a_sDpe, ",");
  
  for ( int i = 1; i <= dynlen(ds); i++ )
  {
    if ( !dpExists(ds[i]) && ds[i] != "" )
    {
      return false;
    }
  }
  
  return true;
}

/** 
  @param a_sPanel 
  @param a_fZoomFactor 
  @param a_iZoomX 
  @param a_iZoomY 
  @param a_sDp_sys_ui 
*/
void CsHmi_setPanelDPs(string a_sPanel,
                       float  a_fZoomFactor = 1.0,
                       int    a_iZoomX = 0,
                       int    a_iZoomY = 0,
                       string a_sDp_sys_ui = "")
{
  string ss = $sDpeSumAlertPanel;
   
   if ( isFunctionDefined("stdTraffic_object_initObjNavigation") )
     strreplace(ss,"_ues_","_ue_");
   
  stdTraffic_hmi_loadPanel("base_" + stdTraffic_hmi_getScreenName (), stdTraffic_hmi_getPanelName(ss));  
}

/** 
  @param dp 
  @param b 
*/
void wrapper_lampenTestCB(string dp, bool b)
{
  strreplace(dp, "sys_lampentest_", "sys_ui_");
  
  strreplace(dp, ".ein", ".lampentest");

  dp = dpSubStr(dp, DPSUB_DP_EL);
  
  dpSet(dp, b);
}

/** 
  @param a_sDpe 
  @param a_uPermission 
  @param a_sUserName 
  @return 
*/
bool CsObject_getUserPermission (string a_sDpe, unsigned a_uPermission = 0, string a_sUserName = "")
{
  strreplace(a_sDpe, ",", "@");
  
  dyn_string dsDps = stringToDynString(a_sDpe, "@");
  
  for ( int i = 1; i <= dynlen(dsDps); i++ )//general konfig anlegen
  {
    string sDp = dpSubStr(dsDps[i], DPSUB_SYS_DP_EL);
    int iType;
    
    if ( strpos(sDp, ".") != -1 )
    {
      dpGet(sDp+":_general.._type", iType);
      
      if ( iType != DPCONFIG_NONE )
        dpSet(sDp+":_general.._type", DPCONFIG_GENERAL);
    }
  }

  return stdTraffic_object_getUserPermissionForDpe(a_sDpe, a_uPermission);
}

//------------------------------------------------------------------------------
/**
 * @date                2005-12-01
 * @brief               Liefert den Tooltip für Elemente im Objekt-Panel zurück
 * @param a_sDpe        Datenpunkt (mehrere DPs sind durch "@" getrennt)
 * @return sTooltip     Tooltip
 * @remarks             derzeit keine Bugs bekannt bzw. behoben.
 */
//------------------------------------------------------------------------------
string CsObject_getToolTip (string a_sDpe)
{
dyn_string dsDpeArray;
string     sAlias;
string     sTooltip;



   dsDpeArray = strsplit (a_sDpe, "@");

   for (int i = 1; i <= dynlen (dsDpeArray); i++) {
      if (dpExists (dsDpeArray[i])) {
         sAlias = dpGetAlias (dsDpeArray[i]);
         
         if (sAlias != "")
            sTooltip = sTooltip + sAlias + ", ";
         else
            sTooltip = sTooltip + dsDpeArray[i] + ", ";
      }
   }
   sTooltip = strrtrim (sTooltip, ", ");
   
   
   return sTooltip;
}

/** 
  @param a_sDpe 
*/
void CsObject_InitObjectMonitoring (string a_sDpe)
{
  stdTraffic_object_initStatusColor(a_sDpe);
}

/** 
  @param a_sDpDefault 
  @param a_sDp 
  @param a_sDpe 
  @param a_sDpBedienart 
  @param a_sDpBetriebsart 
  @param a_sPanelName 
*/
void CsObject_openInfoBasePanel (string a_sDpDefault, string a_sDp, string a_sDpe, string a_sDpBedienart, string a_sDpBetriebsart, string a_sPanelName = "")
{
  string sDp = a_sDp;
  
  if ( a_sDpBedienart != "" )
    sDp += (sDp==""?"":"@") + a_sDpBedienart;
  
  if ( a_sDpBetriebsart != "" )
    sDp += (sDp==""?"":"@") + a_sDpBetriebsart;

  if ( isDollarDefined("$uBerechtigung") )
    stdTraffic_object_openPanel (stdTraffic_intern_getDpTestFileName ("hmi/objektpanel/info_basePanel.xml"), 
                                   "Info - " + stdTraffic_intern_getStringElementDflt (a_sPanelName, "@", 2, dpSubStr (a_sDpDefault, DPSUB_SYS_DP_EL)), 
                                   makeDynString ("$sDp_default:"   + stdTraffic_object_noDpDefaultForBasePanel (a_sDpDefault), 
                                                  "$sDp:"           + sDp, 
                                                  "$sDpe:"          + a_sDpe, 
                                                  "$uBerechtigung:" + $uBerechtigung, 
                                                  "$sPanel:"        + a_sPanelName));
  else
    stdTraffic_object_openPanel (stdTraffic_intern_getDpTestFileName ("hmi/objektpanel/info_basePanel.xml"), 
                                   "Info - " + stdTraffic_intern_getStringElementDflt (a_sPanelName, "@", 2, dpSubStr (a_sDpDefault, DPSUB_SYS_DP_EL)), 
                                   makeDynString ("$sDp_default:"   + stdTraffic_object_noDpDefaultForBasePanel (a_sDpDefault), 
                                                  "$sDp:"           + sDp, 
                                                  "$sDpe:"          + a_sDpe, 
                                                  "$uBerechtigung:" + "",
                                                  "$sPanel:"        + a_sPanelName));
}

/** 
  @param a_sDpDefault 
  @param a_sDp 
  @param a_sDpe 
  @param a_aParameter 
  @param a_uPermission 
  @param a_sPanel 
  @param a_sDpBedienart 
  @param a_sDpBetriebart 
  @param a_sPanelName 
  @param a_sDp_sys_ui 
*/
void CsObject_openObjectPanel (string   a_sDpDefault,
                               string   a_sDp,
                               string   a_sDpe, 
                               anytype  a_aParameter, 
                               unsigned a_uPermission, 
                               string   a_sPanel, 
                               string   a_sDpBedienart, 
                               string   a_sDpBetriebart,
                               string   a_sPanelName = "",
                               string   a_sDp_sys_ui = "")
{

  stdTraffic_object_openPanel(a_sPanel, 
                                   stdTraffic_intern_getStringElementDflt (a_sPanelName, "@", 2, dpSubStr (a_sDpDefault, DPSUB_SYS_DP_EL)), 
                                   makeDynString ("$sDp_default:"   + a_sDpDefault, 
                                                  "$sDp:"           + a_sDp, 
                                                  "$sDpe:"          + a_sDpe, 
                                                  "$aParameter:"    + a_aParameter, 
                                                  "$uBerechtigung:" + a_uPermission, 
                                                  "$sPanel:"        + a_sPanelName,
                                                  "$sDp_bedienart:"  + a_sDpBedienart,
                                                  "$sDp_betriebsart:"+ a_sDpBetriebart));  
  
}

/** 
  @param a_sDpe 
  @param a_sPanelName 
*/
void CsObject_openInfoDetailPanel (string a_sDpe, string a_sPanelName = "")
{
  
  stdTraffic_object_openPanel(stdTraffic_intern_getDpTestFileName("hmi/objektpanel/info_detailPanel.xml"), 
                               "Detail - " + dpGetDescription(a_sDpe), 
                               makeDynString ("$sDpe:" + a_sDpe,
                                              "$uBerechtigung:" + stdTraffic_intern_getAckPermissionLevel()));
}

/** 
  @return 
*/
string CsIntern_rcvHostname()
{
  return strtolower(getHostname());
}

//------------------------------------------------------------------------------
/**
 * @date                   2006-03-13
 * @brief                  prüft ob ein Eingabewert innerhalb des pv-Bereichs liegt
 *                         (es wird davon ausgegangen, dass incl_min und incl_max gesetzt sind)
 * @param a_sDpe           DPE (Sollwert)
 * @param a_sValue         Wert
 * @return bInRange        Rückgabewert (true/false)
 * @remarks                derzeit keine Bugs bekannt bzw. behoben.
 */
//------------------------------------------------------------------------------
bool CsObject_IsValueInPVRange (string a_sDpe, string a_sValue)

{
bool   bInRange;
int    iType;
float  fMin,fMax;
string sReturnValue, sMessage, sFormat;



   dpGet (a_sDpe + ":_pv_range.._type", iType);

   if (iType == DPCONFIG_NONE) {
      bInRange = true;
   }
   else if (iType == DPCONFIG_MINMAX_PVSS_RANGECHECK) {
      dpGet (a_sDpe + ":_pv_range.._min", fMin,
             a_sDpe + ":_pv_range.._max", fMax);
      
      if ((float)a_sValue >= fMin && (float)a_sValue <= fMax) {
         bInRange = true;
      }
      else {
         sMessage = "Eingabe ist ausserhalb des gültigen Wertebereichs. \n(" + 
                     fMin + " - " + fMax + ")";
         
         CsObject_warningPanel (sMessage, "@@OK", sReturnValue);
         bInRange = false;
      }
   }
   else {
      bInRange = true;
   }
   
   return bInRange;
}
//------------------------------------------------------------------------------
/**
 * @date                   2005-12-13
 * @brief                  öffnet ein Panel mit einem Warnhinweis
 * @param a_sWarningText   Warnung als Text im Panel
 * @param a_sButtonText    Text der 3 möglichen Button.
 *                         zB.: "JA@NEIN@OK" oder "JA@NEIN", default "@@OK"
 * @param a_sReturnValue   Rückgabewert von den Buttons
 * @return a_sReturnValue  Rückgabewert von den Buttons
 * @remarks                derzeit keine Bugs bekannt bzw. behoben.
 */
//------------------------------------------------------------------------------
void CsObject_warningPanel (string  a_sWarningText = "", 
                            string  a_sButtonText  = "@@OK", 
                            string &a_sReturnValue)
{
dyn_float  dfResult;
dyn_string dsParameter;
dyn_string dsResult;



   dynAppend (dsParameter, makeDynString ("$sText:" + a_sWarningText,
                                          "$sButtonText:" + a_sButtonText));
    
   ChildPanelOnCentralModalReturn ("hmi/objektpanel/MessageWarning.pnl", 
                                   "Warnung",
                                   dsParameter, dfResult, dsResult);
   
   a_sReturnValue = dsResult[1];
} 

/**
 * @author                    Martin Gayer (GaE)
 * @brief                     Die Funktion liefert einen Fehler (in einer errClass Variable)
 *                            und zeigt eine Fehlermeldung (im Log-Viewer mit entsprechender
 *                            Farbdarstellung) anhand definierter Texte der errors.cat-Datei an. 
 * @date                      2008-03
 * @param a_sPriority         Konstante welche die Wichtigkeit des Fehlers definiert
 *                            (PRIO_FATAL, PRIO_SEVERE, PRIO_WARNING, PRIO_INFO)
 *                            Achtung: bei PRIO_FATAL wird der Manager abgedreht
 * @param a_sType             Konstante, welche den Typ des Fehlers definiert
 *                            (ERR_IMPL, ERR_PARAM, ERR_SYSTEM, ERR_CONTROL, ERR_REDUNDANCY)
 * @param a_iCode             Error-Textnummer für Error-Katalog (ohne führende Nullen)
 * @param a_sText             Zusätzlicher Text für die Ausgabe (üblicherweise Variablen, wie z.B. sDp)
 * @param a_sFunction         Funktion, die die Debug-Ausgabe anreizt.
 * @remarks                   Derzeit keine Bugs bekannt bzw. behoben.
 */
//------------------------------------------------------------------------------
void CsIntern_Debug (string a_sPriority, string a_sType, int a_iCode, string a_sText, string a_sFunction)
{
   errClass ecError; //errClass-Variable für die makeError-Funktion
      
   ecError = makeError ("debug", a_sPriority, a_sType, a_iCode, a_sText, a_sFunction);   
   throwError (ecError); //Gibt den Fehler (Informationsnachricht) aus
}
